-- ADDRESS DECORDER
--		Ver1.0	Date 2000.09.07
--				Produced by Simamu
--		Ver2.0	Date 2000.10.31
--				Produced by Simamu
--		Ver3.0	Date 2000.12.26
--				Produced by Simamu
--		Ver3.1	Date 2000.12.27
--				Produced by Simamu
--		Ver3.2	Date 2000.12.28
--				Produced by Simamu
--		Ver3.3	Date 2001.01.09
--				Produced by Simamu

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY ADD_DEC2 IS
	PORT
	(
		SA					: IN	STD_LOGIC_VECTOR(15 DOWNTO 1);
		MPC_ADD0,MPC_ADD1	: OUT	STD_LOGIC;
		RE_ADD0,RE_ADD1		: OUT	STD_LOGIC;
		GIO_ADD				: OUT	STD_LOGIC
	);
END ADD_DEC2;

ARCHITECTURE DATAFLOW OF ADD_DEC2 IS
BEGIN
PROCESS (SA)
BEGIN
	CASE SA IS
		-- 0310(Hex) for MPC_0 
		WHEN "000000110001000"	=>	MPC_ADD0 	<= '1';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									GIO_ADD		<= '0';
		-- 0312(Hex) for MPC_1							
		WHEN "000000110001001"	=>	MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '1';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									GIO_ADD		<= '0';
		-- 0320(Hex) for RotaryEncoder_0(X)	
		WHEN "000000110010000"	=>	MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '1';
									RE_ADD1  	<= '0';
									GIO_ADD		<= '0';
		-- 0322(Hex) for RotaryEncoder_1(Y)	
		WHEN "000000110010001"	=>	MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '1';
									GIO_ADD		<= '0';
		-- 0300(Hex) for General_IO							
		WHEN "000000110000000"	=>	MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									GIO_ADD		<= '1';
									
		WHEN OTHERS				=>	MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									GIO_ADD		<= '0';
	END CASE;
END PROCESS;
END DATAFLOW;

